import processing.core.*; 
import processing.xml.*; 

import procontroll.*; 
import guicomponents.*; 
import java.awt.AWTException; 
import java.awt.Robot; 
import java.io.*; 
import java.awt.event.KeyEvent; 
import java.awt.event.InputEvent; 
import java.awt.MouseInfo; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class WiiControll extends PApplet {

/*
Mapping a Wii controller to send keystrokes

Utilizes the proCONTROLL library:
http://creativecomputing.cc/p5libs/procontroll/index.htm

Based on Dan Plows's sketch found in this blog post:
http://danplows.com/blog/map-ps3-controller-to-mac-via-bluetooh/

*/





//Libraries for controlling mouse and keyboard





Wiimote[] wiimotes = new Wiimote[0];

String fileName = "settings.txt";
String settings[] = new String[0];

boolean pMousePressed = false;

PFont font;

public void setup(){
    size(400,300);
  //Setup GUI
    guiSetup();
  //Attempt to create an instacne of the "Robot" class
    try{
      robot = new Robot();
    }
    catch (AWTException e) {
      e.printStackTrace();
    }
    controll = ControllIO.getInstance(this);
  //Look for connected wiimotes
  for(int i=0; i<controll.getNumberOfDevices(); i++){
    ControllDevice tempDevice = controll.getDevice(i);
    if(tempDevice.getName().length() > 7){
      if(tempDevice.getName().substring(0, 7).equals("Wiimote")){
        wiimotes =  (Wiimote[])append(wiimotes, new Wiimote(tempDevice.getName()));
        //println(tempDevice.getName());
      }
    }
  }
  //Load Settings
  try{
    getSettings(fileName);
  }
  catch(Exception e){
    //Overwrite settings if loging fails
    saveSettings(fileName);
  }
  //Update status
  if(wiimotes.length > 0){
    statusBar.setText("Found " + wiimotes.length + " connected Wiimote(s)");
  }
  else{
    statusBar.setText("No Wiimotes are connected");
  }
  //Setup fonts
  font = createFont("Monaco", 14);
  textFont(font);
}

public void draw(){
  background(0xffFFFFFF);
    //FiM Macro tests
      //fimMacros(0);
  //Loop for each wiimote
    for(int i=0; i<wiimotes.length; i++){
      //Draw
        stroke(0xff000000);
        if(wiimotes[i].setKey){
            fill(0xff00FFFF, 0x80);
          }
          else{
            noFill();
          }
        rect(i*70+10, 10, 65, 120);
        wiimotes[i].drawWiimote(i*70+45, 10);
        wiimotes[i].drawNunchuk(i*70+12, 30);
      wiimotes[i].loop();
      fill(0xff000000);
      text("#" + str(i+1), i*70+15, 25);
      //Toggle key assignment
        if(!mousePressed && pMousePressed && mouseButton == LEFT && i*70+10 < mouseX && mouseX < i*70+70 && 10 < mouseY && mouseY < 120){
          wiimotes[i].setKey = !wiimotes[i].setKey;
          if(wiimotes[i].setKey){
            statusBar.setText("Ready to set a key for Wiimote#" + str(i+1));
            fill(0xffFFFFFF);
          }
          else{
            statusBar.setText("Canceled key assignment for Wiimote#" + str(i+1));
            fill(0xff0000FF);
          }
        }
      //Button key bindings
        for(int j=0; j<28; j++){
          if(wiimotes[i].pressed(j)){
            keySent = false;
            pKeyCode = -1;
          }
          if(wiimotes[i].setKey){
            if(keySent){
              if(wiimotes[i].buttons[j].pressed() && pKeyCode > -1){
                wiimotes[i].buttonKeyBind(j, pKeyCode);
                statusBar.setText("Set button #" + j + " of Wiimote#" + i + " to keyCode " + keyCode);
                saveSettings(fileName);
                wiimotes[i].setKey = false;
                pKeyCode = -1;
              }
            }
            else{
              if(wiimotes[i].released(j)){
                wiimotes[i].buttonKeyBind(j, -1);
                statusBar.setText("Cleared button " + j + " of Wiimote#" + i);
                saveSettings(fileName);
                wiimotes[i].setKey = false;
              }
            }
          }
        }
    }
  pMousePressed = mousePressed;
}

public void delay(){
  try{
    Thread.sleep(100);
  }
  catch(InterruptedException ie){ }
}
int[] qcRA = {-72, 66, 72, -66, -72, 65, -65};
int[] qcLA = {-70, 66, 70, -66, -70, 65, -65};
int[] qcRB = {-72, 66, 72, -66, -72, 83, -83};
int[] qcLB = {-70, 66, 70, -66, -70, 83, -83};
int[] qcRC = {-72, 66, 72, -66, -72, 68, -68};
int[] qcLC = {-70, 66, 70, -66, -70, 68, -68};
int[] qcRD = {-72, 66, 72, -66, -72, 81, -81};
int[] qcLD = {-70, 66, 70, -66, -70, 81, -81};

int[] skLA = {70, -70, 66, 70, -66, 65, -70, -65};
int[] skRA = {72, -72, 66, 72, -65, 65, -72, -65};
int[] skLB = {70, -70, 66, 70, -66, 83, -70, -83};
int[] skRB = {72, -72, 66, 72, -66, 83, -72, -83};
int[] skLC = {70, -70, 66, 70, -66, 68, -70, -68};
int[] skRC = {72, -72, 66, 72, -66, 68, -72, -68};
int[] skLD = {70, -70, 66, 70, -66, 81, -70, -81};
int[] skRD = {72, -72, 66, 72, -66, 81, -72, -81};

public void fimMacros(int wiimote){
  if(wiimotes[wiimote].chukStickDir == 4){
    if(wiimotes[wiimote].buttonsPressed[4]){
      macro(qcLA);
    }
    if(wiimotes[wiimote].buttonsPressed[11]){
      macro(skLA);
    }
    if(wiimotes[wiimote].buttonsPressed[5]){
      macro(qcLC);
    }
    if(wiimotes[wiimote].buttonsPressed[12]){
      macro(skLC);
    }
  }
  if(wiimotes[wiimote].chukStickDir == 6){
    if(wiimotes[wiimote].buttonsPressed[4]){
      macro(qcRA);
    }
    if(wiimotes[wiimote].buttonsPressed[11]){
      macro(skRA);
    }
    if(wiimotes[wiimote].buttonsPressed[5]){
      macro(qcRC);
    }
    if(wiimotes[wiimote].buttonsPressed[12]){
      macro(skRC);
    }
  }
}

public void macro(int[] keyStrokes){
  for(int i=0; i<keyStrokes.length; i++){
    if(keyStrokes[i] > 0){
      robot.keyPress(keyStrokes[i]);
      println("Pressed " + keyStrokes[i]);
    }
    else{
      robot.keyRelease(-keyStrokes[i]);
      println("Released " + -keyStrokes[i]);
    }
    delay(50);
  }
  println();
}

GLabel statusBar;

public void guiSetup(){
  statusBar = new GLabel(this, "Status Bar", 0, height-20, width-1, 20);
  statusBar.setFont("Monaco", 14);
  statusBar.setBorder(1);
  statusBar.setOpaque(true);
  statusBar.setColorScheme(GCScheme.CYAN_SCHEME);
}
Robot robot;
ControllIO controll;

class Wiimote{
  ControllDevice device = null;
  String name;
  boolean setKey = false;
  
  ControllSlider[] sliders = new ControllSlider[6];
  
  ControllButton[] buttons = new ControllButton[28];
  boolean[] buttonsPressed = new boolean[28];
  int[] buttonKeyBindings = new int[28];
  int[] buttonMouseBindings = new int[28];
  
  int button = -1;
  int pButton = -1;
  
  ControllStick[] sticks = new ControllStick[3];
  //ChukStick
    int[] chukStickBindings = new int[9];
    int chukStickDir = 5;
    int pChukStickDir = 5;
    //Modes
    //4: 0 Mouse Mode
    //4: 4 direction.  Sends both key presses on a diagonals
    //8: 8 direction.  Sends a different key presses on a diagonals
    int chukStickMode = -1;
    float chuckStickXthreshhold = 0.66f;
    float chuckStickYthreshhold = 0.66f;
    float chuckStickThreshhold = 0.66f;
    int mouseXMax = 10;
    int mouseYMax = 10;
  
  String[] btnDefinitions = {"BTN.LT",
                             "BTN.RT",
                             "BTN.UP",
                             "BTN.DN",
                             "BTN.A",
                             "BTN.B",
                             "BTN.+",
                             "BTN.-",
                             "BTN.HOME",
                             "BTN.1",
                             "BTN.2",
                             "BTN.C",
                             "BTN.Z",
                            };
  String[] jsDefinitions = {"JS.NW",
                            "JS.NN",
                            "JS.NE",
                            "JS.WW",
                            "JS.CTR",
                            "JS.EE",
                            "JS.SW",
                            "JS.SS",
                            "JS.SE",
                            "JS.Mode",
                            "JS.Threshold"
                           };

  Wiimote(String name){
    this.name = name;
    try{
      device = controll.getDevice(name);
      //Get buttons and initilize key/mouse button bindings
        for(int i=0; i<28; i++){
          buttonsPressed[i] = false;
          buttonKeyBindings[i] = -1;
          buttonMouseBindings[i] = -1;
          buttons[i] = device.getButton(str(i));
        }
      //Get sticks
        sticks[0] = device.getStick("y x");
        for(int i=0; i<9; i++){
          chukStickBindings[i] = -1;
        }
    }
    catch(Exception e){
      //println("No device with name: \"" + name + "\"");
    }
  }
  
  Tooltip[] tooltips = new Tooltip[28];
  
  public void drawWiimote(int x, int y){
    if(device != null){
      pushMatrix();
        translate(x,y);
        stroke(0xff000000);
        noFill();
        rect(0, 0, 30, 120);
        //D-pad
          noStroke();
          fillButton(0);
          rect(6, 18, 7, 7);
          tooltips[0] = new Tooltip(str(buttonKeyBindings[0]), x + 6, y + 18, 7, 7);
          fillButton(1);
          rect(18, 18, 7, 7);
          tooltips[1] = new Tooltip(str(buttonKeyBindings[1]), x + 18, y + 18, 7, 7);
          fillButton(2);
          rect(12, 12, 7, 7);
          tooltips[2] = new Tooltip(str(buttonKeyBindings[2]), x + 12, y + 12, 7, 7);
          fillButton(3);
          rect(12, 24, 7, 7);
          tooltips[3] = new Tooltip(str(buttonKeyBindings[3]), x + 12, y + 24, 7, 7);
          noFill();
          stroke(0xff000000);
          beginShape();
          vertex(12, 12);
          vertex(18, 12);
          vertex(18, 18);
          vertex(24, 18);
          vertex(24, 24);
          vertex(18, 24);
          vertex(18, 30);
          vertex(12, 30);
          vertex(12, 24);
          vertex(6, 24);
          vertex(6, 18);
          vertex(12, 18);
          endShape(CLOSE);
        //Other Buttons
          fillButton(4);
          ellipse(15, 45, 10, 10);
          tooltips[4] = new Tooltip(str(buttonKeyBindings[4]), x + 10, y + 40, 10, 10);
          fillButton(5);
          rect(21, 30, 6, 9);
          tooltips[5] = new Tooltip(str(buttonKeyBindings[5]), x + 21, y + 30, 6, 9);
          fillButton(7);
          ellipse(8, 60, 6, 6);
          tooltips[7] = new Tooltip(str(buttonKeyBindings[7]), x + 5, y + 57, 6, 6);
          fillButton(8);
          ellipse(15, 60, 6, 6);
          tooltips[8] = new Tooltip(str(buttonKeyBindings[8]), x + 12, y + 57, 6, 6);
          fillButton(6);
          ellipse(22, 60, 6, 6);
          tooltips[6] = new Tooltip(str(buttonKeyBindings[6]), x + 18, y + 57, 6, 6);
          fillButton(9);
          ellipse(15, 81, 8, 8);
          tooltips[9] = new Tooltip(str(buttonKeyBindings[9]), x + 12, y + 78, 8, 8);
          fillButton(10);
          ellipse(15, 93, 8, 8);
          tooltips[10] = new Tooltip(str(buttonKeyBindings[10]), x + 12, y + 90, 8, 8);
        popMatrix();
    }
  }
  
  public void drawNunchuk(int x, int y){
    if(device != null){
      pushMatrix();
        translate(x,y);
        stroke(0xff000000);
        noFill();
        ellipse(15, 50, 30, 100);
        stroke(0xff000000);
          ellipse(15 + sticks[0].getY() * 4, 30+ sticks[0].getX() * 4, 8, 8);
          fillButton(11);
          ellipse(17, 10, 8, 8);
          tooltips[11] = new Tooltip(str(buttonKeyBindings[11]), x + 13, y + 6, 8, 8);
          fillButton(12);
          rect(11, 15, 10, 6);
          tooltips[12] = new Tooltip(str(buttonKeyBindings[12]), x + 11, y + 15, 10, 6);
          line(15, 30, 11 + (chukStickDir+2)%3*4, 26 + (chukStickDir-1)/3*4);
        popMatrix();
    }
  }
  
  public void fillButton(int n){
    fill(0xffFFFFFF);
    if(buttonsPressed[n] == true){
      fill(0xff808080);
      if(buttonKeyBindings[n] != -1){
        fill(0xff40D040);
      }
    }
    else{
      if(buttonKeyBindings[n] != -1){
        fill(0xff00FF00);
      }
    }
  }
  
  public void loop(){
    for(int i=0; i<tooltips.length; i++){
      if(tooltips[i] != null){
        tooltips[i].loop();
      }
    }
    if(device != null){
      if(!setKey){
        //Send keystrokes
          //Buttons
            buttonKeystroke();
          //ChukStick
            setChukStickDir();
            switch(chukStickMode){
              case 0:
                chukStickMouse();
              case 4:
                chukStick4DirMode();
                break;
              case 8:
                chukStick8DirMode();
                break;
              default:
                //println(name + " has been set to undefined chukStickMode: " + chukStickMode);
        }
      }
    }
  }
  
  public void chukStickMouse(){
    buttonMouseBindings[12] = InputEvent.BUTTON1_MASK;
    buttonMouseBindings[11] = InputEvent.BUTTON3_MASK;
    float joyX = sticks[0].getY();
    float joyY = sticks[0].getX();
    //println(joyX + "," + joyY);
    //println(MouseInfo.getPointerInfo().getLocation().x + "," + MouseInfo.getPointerInfo().getLocation().y);
    //if(abs(joyX) > chuckStickXthreshhold){
    if(abs(joyX) > chuckStickThreshhold){
      robot.mouseMove(MouseInfo.getPointerInfo().getLocation().x + PApplet.parseInt(mouseXMax* joyX), MouseInfo.getPointerInfo().getLocation().y);
    }
    //if(abs(joyX) > chuckStickYthreshhold){
    if(abs(joyX) > chuckStickThreshhold){
      robot.mouseMove(MouseInfo.getPointerInfo().getLocation().x, MouseInfo.getPointerInfo().getLocation().y + PApplet.parseInt(mouseXMax*joyY));
    }
  }
  
  public void chukStick4DirMode(){
    //Horizontal movement
      if(chukStickDir%3 != pChukStickDir%3){
        if(chukStickBindings[3 + (pChukStickDir-1)%3] != -1){
          //println(name + " released ChukStick " + (4 + (pChukStickDir-1)%3));
          robot.keyRelease(chukStickBindings[3 + (pChukStickDir-1)%3]);
        }
        if(chukStickBindings[3 + (chukStickDir-1)%3] != -1){
          //println(name + " pressed ChukStick " + (4 + (chukStickDir-1)%3));
          robot.keyPress(chukStickBindings[3 + (chukStickDir-1)%3]);
          //delay();
        }
      }
    //Vertical movement
      if(PApplet.parseInt((chukStickDir-1)/3) != PApplet.parseInt((pChukStickDir-1)/3)){
        if(chukStickBindings[1 + 3 * PApplet.parseInt((pChukStickDir-1)/3)] != -1){
          //println(name + " released ChukStick " + (2 + 3 * int((pChukStickDir-1)/3)) );
          robot.keyRelease(chukStickBindings[1 + 3 * PApplet.parseInt((pChukStickDir-1)/3)]);
        }
        if(chukStickBindings[1 + 3 * PApplet.parseInt((chukStickDir-1)/3)] != -1){
          //println(name + " pressed ChukStick " + (2 + 3 * int((chukStickDir-1)/3)) );
          robot.keyPress(chukStickBindings[1 + 3 * PApplet.parseInt((chukStickDir-1)/3)]);
          //delay();
        }
      }
  }
  
  public void chukStick8DirMode(){
    //Release previous key and press current if there is a change
      if(chukStickDir != pChukStickDir){
        if(chukStickBindings[pChukStickDir-1] != -1){
          //println(name + " released ChukStick " + pChukStickDir);
          robot.keyRelease(chukStickBindings[pChukStickDir-1]);
        }
        if(chukStickBindings[chukStickDir-1] != -1){
          //println(name + " pressed ChukStick " + chukStickDir);
          robot.keyPress(chukStickBindings[chukStickDir-1]);
          //delay();
        }
      }
  }
  
  public void setChukStickDir(){
    //Map joystick postions to their corrosponding numbers keypad
    //For example, left is mapped to 4
      if(pChukStickDir != chukStickDir){
        pChukStickDir = chukStickDir;
      }
      chukStickDir = 5;
      //if(sticks[0].getX() > chuckStickXthreshhold){
      if(sticks[0].getX() > chuckStickThreshhold){
        chukStickDir = chukStickDir + 3;
      }
      //if(sticks[0].getX() < -chuckStickXthreshhold){
      if(sticks[0].getX() < -chuckStickThreshhold){
        chukStickDir = chukStickDir - 3;
      }
      //if(sticks[0].getY() > chuckStickYthreshhold){
      if(sticks[0].getY() > chuckStickThreshhold){
        chukStickDir = chukStickDir + 1;
      }
      //if(sticks[0].getY() < -chuckStickYthreshhold){
      if(sticks[0].getY() < -chuckStickThreshhold){
        chukStickDir = chukStickDir - 1;
      }
  }
  
  public void buttonKeystroke(){
    for(int i=0; i<28; i++){
      if(pressed(i)){
        //Send keystroke
          if(buttonKeyBindings[i] != -1){
            //println(name + " pressed button " + str(i));
            robot.keyPress(buttonKeyBindings[i]);
          }
          if(buttonMouseBindings[i] != -1){
            //println(name + " pressed button " + str(i));
            robot.mousePress(buttonMouseBindings[i]);
          }
        //delay();
      }
      if(released(i)){
        //Release Key
          if(buttonKeyBindings[i] != -1){
            //println(name + " released button " + str(i));
            robot.keyRelease(buttonKeyBindings[i]);
          }
          if(buttonMouseBindings[i] != -1){
            //println(name + " released button " + str(i));
            robot.mouseRelease(buttonMouseBindings[i]);
          }
      }
    }
  }
  
  public boolean pressed(int buttonNumber){
    if(device != null){
      if(buttons[buttonNumber].pressed()){
        if(!buttonsPressed[buttonNumber]){
          buttonsPressed[buttonNumber] = true;
          return(true);
        }
        else{
          return(false);
        }
      }
      else{
        return(false);
      }
    }
    else{
      return(false);
    }
  }
  
  public boolean released(int buttonNumber){
    if(!buttons[buttonNumber].pressed()){
      if(buttonsPressed[buttonNumber]){
        buttonsPressed[buttonNumber] = false;
        return(true);
      }
      else{
        return(false);
      }
    }
    else{
      return(false);
    }
  }
  
  public void buttonKeyBind(int buttonNumber, int code){
    //Binds keyCode to ButtonNumber button of the Wiimote
    buttonKeyBindings[buttonNumber] = code;
  }
}
public void saveSettings(String name) {
  statusBar.setText("Saving. . .");
  settings = new String[0];
  //Iterate over wiimotes
  for (int i=0; i<wiimotes.length; i++) {
    settings = append(settings, "Wiimote " + str(i+1));
    //Iterate over button settings
    for (int j=0; j<13; j++) {
      settings = append(settings, wiimotes[i].btnDefinitions[j] + "=" + str(wiimotes[i].buttonKeyBindings[j]));
    }
    //Iterate over joystick settings
    for (int j=0; j<9; j++) {
      settings = append(settings, wiimotes[i].jsDefinitions[j] + "=" + str(wiimotes[i].chukStickBindings[j]));
    }
    //Joystick mode
    settings = append(settings, wiimotes[i].jsDefinitions[9] + "=" + str(wiimotes[i].chukStickMode));
    //Joystick threshold
    settings = append(settings, wiimotes[i].jsDefinitions[10] + "=" + str(wiimotes[i].chuckStickThreshhold));
  }
  saveStrings(fileName, settings);
  statusBar.setText("Saved");
}

public void getSettings(String name) {
  if (settings == null) {
    statusBar.setText("\"" + name + "\"" + "could not be found");
  }
  else {
    settings = loadStrings(name);
    //Set up wiimotes
    int curWiimote = -1;
    for (int i=0; i<settings.length; i++) {
      //Trim whitespace
      if (settings[i].indexOf('=') != -1) {
        settings[i] = trim(settings[i].substring(0, settings[i].indexOf('='))) + "=" + trim(settings[i].substring(settings[i].indexOf('=')+1, settings[i].length()));
      }
      //Search for wiimote header
      if (settings[i].length() > 7) {
        if (settings[i].substring(0, 7).equals("Wiimote")) {
          curWiimote = curWiimote + 1;
          settings[i] = "Wiimote " + str(curWiimote + 1);
          if (curWiimote != -1 && curWiimote < wiimotes.length) {
            //println("Setting up Wiimote#" + curWiimote);
          }
        }
      }
      //Check settings
      if (curWiimote != -1 && curWiimote < wiimotes.length) {
        if (settings[i].indexOf('=') != -1) {
          //Set setting
          String code = "";
          String var = settings[i].substring(0, settings[i].indexOf('='));
          try {
            code = settings[i].substring(settings[i].indexOf('=')+1, settings[i].length());
            var = settings[i].substring(0, settings[i].indexOf('='));
            //Check for non numerical settings
            if (PApplet.parseInt(code) != 0 || PApplet.parseFloat(code) != 0) {
              //Iterate over button settings
              for (int j=0; j<13; j++) {
                if (settings[i].substring(0, settings[i].indexOf('=')).equals(wiimotes[curWiimote].btnDefinitions[j])) {
                  //println("Got button #" + j + ": " + settings[i].substring(0, settings[i].indexOf('=')) + ", " + code);
                  wiimotes[curWiimote].buttonKeyBindings[j] = PApplet.parseInt(code);
                }
              }
              //Iterate over joystick settings
              for (int j=0; j<9; j++) {
                if (settings[i].substring(0, settings[i].indexOf('=')).equals(wiimotes[curWiimote].jsDefinitions[j])) {
                  //println("Got joystick Setting #" + j + ": " + settings[i].substring(0, settings[i].indexOf('=')) + ", " + int(code));
                  wiimotes[curWiimote].chukStickBindings[j] = PApplet.parseInt(code);
                }
              }
              if (settings[i].substring(0, settings[i].indexOf('=')).equals(wiimotes[curWiimote].jsDefinitions[9])) {
                //println("Got joystick mode: " + settings[i].substring(0, settings[i].indexOf('=')) + ", " + code);
                wiimotes[curWiimote].chukStickMode = PApplet.parseInt(code);
              }
              if (settings[i].substring(0, settings[i].indexOf('=')).equals(wiimotes[curWiimote].jsDefinitions[10])) {
                //println("Got joystick threshold: " + settings[i].substring(0, settings[i].indexOf('=')) + ", " + code);
                wiimotes[curWiimote].chuckStickThreshhold = PApplet.parseFloat(code);
              }
            }
            else {
              println("Invalid setting at line " + i + ": \"" + settings[i] + "\"");
            }
          }
          catch(Exception e) {
            println("An unknown error has occurred at line " + i);
          }
        }
      }
    }
    //Save parsed settings
    saveStrings(name, settings);
  }
}

/*
Wiimote

    Sliders:
         x absolute:
         y absolute:
         z absolute:
        rx absolute:
        xy absolute:
        rz absolute:
    Buttons:
         0: D-pad Left
         1: D-pad Right
         2: D-pad Up
         3: D-pad Down
         4: A
         5: B
         6: +
         7: -
         8: Home
         9: 1
        10: 2
        11: Nunchuk C
        12: Nunchuk Z
        13: 
        14:
        15:
        16:
        17:
        18:
        19:
        20:
        21:
        22:
        23:
        24:
        25:
        26:
        27:
    Sticks:
        y x:   Nunchuk Joystick  *Important Note: X and Y axes are swapped
        rx z:  
        rx ry: 
*/
boolean keySent = false;
int pKeyCode = -1;

public void keyReleased(){
  pKeyCode = keyCode;
  keySent = true;
}
class Tooltip{
  int x;
  int y;
  int w;
  int h;
  int xOff = 8; 
  int yOff = 30;
  String msg;
  
  Tooltip(String msg, int x, int y, int w, int h){
    this.x = x;
    this.y = y;
    this.w = w;
    this.h = h;
    this.msg = msg;
  }
  
  public void loop(){
    noStroke();
    if(x < mouseX && mouseX < x + w && y < mouseY && mouseY < y + h){
      stroke(0xff000000);
      strokeWeight(1);
      fill(0xffFFFFFF);
      rect(mouseX + xOff - 1, mouseY + yOff - 13, msg.length() * 8 + 2, 14);
      fill(0xff000000);
      text(msg, mouseX + xOff, mouseY + yOff);
    }
  }
}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "WiiControll" });
  }
}
