Robot robot;
ControllIO controll;

class Wiimote{
  ControllDevice device = null;
  String name;
  boolean setKey = false;
  
  ControllSlider[] sliders = new ControllSlider[6];
  
  ControllButton[] buttons = new ControllButton[28];
  boolean[] buttonsPressed = new boolean[28];
  int[] buttonKeyBindings = new int[28];
  int[] buttonMouseBindings = new int[28];
  
  int button = -1;
  int pButton = -1;
  
  ControllStick[] sticks = new ControllStick[3];
  //ChukStick
    int[] chukStickBindings = new int[9];
    int chukStickDir = 5;
    int pChukStickDir = 5;
    //Modes
    //4: 0 Mouse Mode
    //4: 4 direction.  Sends both key presses on a diagonals
    //8: 8 direction.  Sends a different key presses on a diagonals
    int chukStickMode = -1;
    float chuckStickXthreshhold = 0.66;
    float chuckStickYthreshhold = 0.66;
    float chuckStickThreshhold = 0.66;
    int mouseXMax = 10;
    int mouseYMax = 10;
  
  String[] btnDefinitions = {"BTN.LT",
                             "BTN.RT",
                             "BTN.UP",
                             "BTN.DN",
                             "BTN.A",
                             "BTN.B",
                             "BTN.+",
                             "BTN.-",
                             "BTN.HOME",
                             "BTN.1",
                             "BTN.2",
                             "BTN.C",
                             "BTN.Z",
                            };
  String[] jsDefinitions = {"JS.NW",
                            "JS.NN",
                            "JS.NE",
                            "JS.WW",
                            "JS.CTR",
                            "JS.EE",
                            "JS.SW",
                            "JS.SS",
                            "JS.SE",
                            "JS.Mode",
                            "JS.Threshold"
                           };

  Wiimote(String name){
    this.name = name;
    try{
      device = controll.getDevice(name);
      //Get buttons and initilize key/mouse button bindings
        for(int i=0; i<28; i++){
          buttonsPressed[i] = false;
          buttonKeyBindings[i] = -1;
          buttonMouseBindings[i] = -1;
          buttons[i] = device.getButton(str(i));
        }
      //Get sticks
        sticks[0] = device.getStick("y x");
        for(int i=0; i<9; i++){
          chukStickBindings[i] = -1;
        }
    }
    catch(Exception e){
      //println("No device with name: \"" + name + "\"");
    }
  }
  
  Tooltip[] tooltips = new Tooltip[28];
  
  void drawWiimote(int x, int y){
    if(device != null){
      pushMatrix();
        translate(x,y);
        stroke(#000000);
        noFill();
        rect(0, 0, 30, 120);
        //D-pad
          noStroke();
          fillButton(0);
          rect(6, 18, 7, 7);
          tooltips[0] = new Tooltip(str(buttonKeyBindings[0]), x + 6, y + 18, 7, 7);
          fillButton(1);
          rect(18, 18, 7, 7);
          tooltips[1] = new Tooltip(str(buttonKeyBindings[1]), x + 18, y + 18, 7, 7);
          fillButton(2);
          rect(12, 12, 7, 7);
          tooltips[2] = new Tooltip(str(buttonKeyBindings[2]), x + 12, y + 12, 7, 7);
          fillButton(3);
          rect(12, 24, 7, 7);
          tooltips[3] = new Tooltip(str(buttonKeyBindings[3]), x + 12, y + 24, 7, 7);
          noFill();
          stroke(#000000);
          beginShape();
          vertex(12, 12);
          vertex(18, 12);
          vertex(18, 18);
          vertex(24, 18);
          vertex(24, 24);
          vertex(18, 24);
          vertex(18, 30);
          vertex(12, 30);
          vertex(12, 24);
          vertex(6, 24);
          vertex(6, 18);
          vertex(12, 18);
          endShape(CLOSE);
        //Other Buttons
          fillButton(4);
          ellipse(15, 45, 10, 10);
          tooltips[4] = new Tooltip(str(buttonKeyBindings[4]), x + 10, y + 40, 10, 10);
          fillButton(5);
          rect(21, 30, 6, 9);
          tooltips[5] = new Tooltip(str(buttonKeyBindings[5]), x + 21, y + 30, 6, 9);
          fillButton(7);
          ellipse(8, 60, 6, 6);
          tooltips[7] = new Tooltip(str(buttonKeyBindings[7]), x + 5, y + 57, 6, 6);
          fillButton(8);
          ellipse(15, 60, 6, 6);
          tooltips[8] = new Tooltip(str(buttonKeyBindings[8]), x + 12, y + 57, 6, 6);
          fillButton(6);
          ellipse(22, 60, 6, 6);
          tooltips[6] = new Tooltip(str(buttonKeyBindings[6]), x + 18, y + 57, 6, 6);
          fillButton(9);
          ellipse(15, 81, 8, 8);
          tooltips[9] = new Tooltip(str(buttonKeyBindings[9]), x + 12, y + 78, 8, 8);
          fillButton(10);
          ellipse(15, 93, 8, 8);
          tooltips[10] = new Tooltip(str(buttonKeyBindings[10]), x + 12, y + 90, 8, 8);
        popMatrix();
    }
  }
  
  void drawNunchuk(int x, int y){
    if(device != null){
      pushMatrix();
        translate(x,y);
        stroke(#000000);
        noFill();
        ellipse(15, 50, 30, 100);
        stroke(#000000);
          ellipse(15 + sticks[0].getY() * 4, 30+ sticks[0].getX() * 4, 8, 8);
          fillButton(11);
          ellipse(17, 10, 8, 8);
          tooltips[11] = new Tooltip(str(buttonKeyBindings[11]), x + 13, y + 6, 8, 8);
          fillButton(12);
          rect(11, 15, 10, 6);
          tooltips[12] = new Tooltip(str(buttonKeyBindings[12]), x + 11, y + 15, 10, 6);
          line(15, 30, 11 + (chukStickDir+2)%3*4, 26 + (chukStickDir-1)/3*4);
        popMatrix();
    }
  }
  
  void fillButton(int n){
    fill(#FFFFFF);
    if(buttonsPressed[n] == true){
      fill(#808080);
      if(buttonKeyBindings[n] != -1){
        fill(#40D040);
      }
    }
    else{
      if(buttonKeyBindings[n] != -1){
        fill(#00FF00);
      }
    }
  }
  
  void loop(){
    for(int i=0; i<tooltips.length; i++){
      if(tooltips[i] != null){
        tooltips[i].loop();
      }
    }
    if(device != null){
      if(!setKey){
        //Send keystrokes
          //Buttons
            buttonKeystroke();
          //ChukStick
            setChukStickDir();
            switch(chukStickMode){
              case 0:
                chukStickMouse();
              case 4:
                chukStick4DirMode();
                break;
              case 8:
                chukStick8DirMode();
                break;
              default:
                //println(name + " has been set to undefined chukStickMode: " + chukStickMode);
        }
      }
    }
  }
  
  void chukStickMouse(){
    buttonMouseBindings[12] = InputEvent.BUTTON1_MASK;
    buttonMouseBindings[11] = InputEvent.BUTTON3_MASK;
    float joyX = sticks[0].getY();
    float joyY = sticks[0].getX();
    //println(joyX + "," + joyY);
    //println(MouseInfo.getPointerInfo().getLocation().x + "," + MouseInfo.getPointerInfo().getLocation().y);
    //if(abs(joyX) > chuckStickXthreshhold){
    if(abs(joyX) > chuckStickThreshhold){
      robot.mouseMove(MouseInfo.getPointerInfo().getLocation().x + int(mouseXMax* joyX), MouseInfo.getPointerInfo().getLocation().y);
    }
    //if(abs(joyX) > chuckStickYthreshhold){
    if(abs(joyX) > chuckStickThreshhold){
      robot.mouseMove(MouseInfo.getPointerInfo().getLocation().x, MouseInfo.getPointerInfo().getLocation().y + int(mouseXMax*joyY));
    }
  }
  
  void chukStick4DirMode(){
    //Horizontal movement
      if(chukStickDir%3 != pChukStickDir%3){
        if(chukStickBindings[3 + (pChukStickDir-1)%3] != -1){
          //println(name + " released ChukStick " + (4 + (pChukStickDir-1)%3));
          robot.keyRelease(chukStickBindings[3 + (pChukStickDir-1)%3]);
        }
        if(chukStickBindings[3 + (chukStickDir-1)%3] != -1){
          //println(name + " pressed ChukStick " + (4 + (chukStickDir-1)%3));
          robot.keyPress(chukStickBindings[3 + (chukStickDir-1)%3]);
          //delay();
        }
      }
    //Vertical movement
      if(int((chukStickDir-1)/3) != int((pChukStickDir-1)/3)){
        if(chukStickBindings[1 + 3 * int((pChukStickDir-1)/3)] != -1){
          //println(name + " released ChukStick " + (2 + 3 * int((pChukStickDir-1)/3)) );
          robot.keyRelease(chukStickBindings[1 + 3 * int((pChukStickDir-1)/3)]);
        }
        if(chukStickBindings[1 + 3 * int((chukStickDir-1)/3)] != -1){
          //println(name + " pressed ChukStick " + (2 + 3 * int((chukStickDir-1)/3)) );
          robot.keyPress(chukStickBindings[1 + 3 * int((chukStickDir-1)/3)]);
          //delay();
        }
      }
  }
  
  void chukStick8DirMode(){
    //Release previous key and press current if there is a change
      if(chukStickDir != pChukStickDir){
        if(chukStickBindings[pChukStickDir-1] != -1){
          //println(name + " released ChukStick " + pChukStickDir);
          robot.keyRelease(chukStickBindings[pChukStickDir-1]);
        }
        if(chukStickBindings[chukStickDir-1] != -1){
          //println(name + " pressed ChukStick " + chukStickDir);
          robot.keyPress(chukStickBindings[chukStickDir-1]);
          //delay();
        }
      }
  }
  
  void setChukStickDir(){
    //Map joystick postions to their corrosponding numbers keypad
    //For example, left is mapped to 4
      if(pChukStickDir != chukStickDir){
        pChukStickDir = chukStickDir;
      }
      chukStickDir = 5;
      //if(sticks[0].getX() > chuckStickXthreshhold){
      if(sticks[0].getX() > chuckStickThreshhold){
        chukStickDir = chukStickDir + 3;
      }
      //if(sticks[0].getX() < -chuckStickXthreshhold){
      if(sticks[0].getX() < -chuckStickThreshhold){
        chukStickDir = chukStickDir - 3;
      }
      //if(sticks[0].getY() > chuckStickYthreshhold){
      if(sticks[0].getY() > chuckStickThreshhold){
        chukStickDir = chukStickDir + 1;
      }
      //if(sticks[0].getY() < -chuckStickYthreshhold){
      if(sticks[0].getY() < -chuckStickThreshhold){
        chukStickDir = chukStickDir - 1;
      }
  }
  
  void buttonKeystroke(){
    for(int i=0; i<28; i++){
      if(pressed(i)){
        //Send keystroke
          if(buttonKeyBindings[i] != -1){
            //println(name + " pressed button " + str(i));
            robot.keyPress(buttonKeyBindings[i]);
          }
          if(buttonMouseBindings[i] != -1){
            //println(name + " pressed button " + str(i));
            robot.mousePress(buttonMouseBindings[i]);
          }
        //delay();
      }
      if(released(i)){
        //Release Key
          if(buttonKeyBindings[i] != -1){
            //println(name + " released button " + str(i));
            robot.keyRelease(buttonKeyBindings[i]);
          }
          if(buttonMouseBindings[i] != -1){
            //println(name + " released button " + str(i));
            robot.mouseRelease(buttonMouseBindings[i]);
          }
      }
    }
  }
  
  boolean pressed(int buttonNumber){
    if(device != null){
      if(buttons[buttonNumber].pressed()){
        if(!buttonsPressed[buttonNumber]){
          buttonsPressed[buttonNumber] = true;
          return(true);
        }
        else{
          return(false);
        }
      }
      else{
        return(false);
      }
    }
    else{
      return(false);
    }
  }
  
  boolean released(int buttonNumber){
    if(!buttons[buttonNumber].pressed()){
      if(buttonsPressed[buttonNumber]){
        buttonsPressed[buttonNumber] = false;
        return(true);
      }
      else{
        return(false);
      }
    }
    else{
      return(false);
    }
  }
  
  void buttonKeyBind(int buttonNumber, int code){
    //Binds keyCode to ButtonNumber button of the Wiimote
    buttonKeyBindings[buttonNumber] = code;
  }
}
