void saveSettings(String name) {
  statusBar.setText("Saving. . .");
  settings = new String[0];
  //Iterate over wiimotes
  for (int i=0; i<wiimotes.length; i++) {
    settings = append(settings, "Wiimote " + str(i+1));
    //Iterate over button settings
    for (int j=0; j<13; j++) {
      settings = append(settings, wiimotes[i].btnDefinitions[j] + "=" + str(wiimotes[i].buttonKeyBindings[j]));
    }
    //Iterate over joystick settings
    for (int j=0; j<9; j++) {
      settings = append(settings, wiimotes[i].jsDefinitions[j] + "=" + str(wiimotes[i].chukStickBindings[j]));
    }
    //Joystick mode
    settings = append(settings, wiimotes[i].jsDefinitions[9] + "=" + str(wiimotes[i].chukStickMode));
    //Joystick threshold
    settings = append(settings, wiimotes[i].jsDefinitions[10] + "=" + str(wiimotes[i].chuckStickThreshhold));
  }
  saveStrings(fileName, settings);
  statusBar.setText("Saved");
}

void getSettings(String name) {
  if (settings == null) {
    statusBar.setText("\"" + name + "\"" + "could not be found");
  }
  else {
    settings = loadStrings(name);
    //Set up wiimotes
    int curWiimote = -1;
    for (int i=0; i<settings.length; i++) {
      //Trim whitespace
      if (settings[i].indexOf('=') != -1) {
        settings[i] = trim(settings[i].substring(0, settings[i].indexOf('='))) + "=" + trim(settings[i].substring(settings[i].indexOf('=')+1, settings[i].length()));
      }
      //Search for wiimote header
      if (settings[i].length() > 7) {
        if (settings[i].substring(0, 7).equals("Wiimote")) {
          curWiimote = curWiimote + 1;
          settings[i] = "Wiimote " + str(curWiimote + 1);
          if (curWiimote != -1 && curWiimote < wiimotes.length) {
            //println("Setting up Wiimote#" + curWiimote);
          }
        }
      }
      //Check settings
      if (curWiimote != -1 && curWiimote < wiimotes.length) {
        if (settings[i].indexOf('=') != -1) {
          //Set setting
          String code = "";
          String var = settings[i].substring(0, settings[i].indexOf('='));
          try {
            code = settings[i].substring(settings[i].indexOf('=')+1, settings[i].length());
            var = settings[i].substring(0, settings[i].indexOf('='));
            //Check for non numerical settings
            if (int(code) != 0 || float(code) != 0) {
              //Iterate over button settings
              for (int j=0; j<13; j++) {
                if (settings[i].substring(0, settings[i].indexOf('=')).equals(wiimotes[curWiimote].btnDefinitions[j])) {
                  //println("Got button #" + j + ": " + settings[i].substring(0, settings[i].indexOf('=')) + ", " + code);
                  wiimotes[curWiimote].buttonKeyBindings[j] = int(code);
                }
              }
              //Iterate over joystick settings
              for (int j=0; j<9; j++) {
                if (settings[i].substring(0, settings[i].indexOf('=')).equals(wiimotes[curWiimote].jsDefinitions[j])) {
                  //println("Got joystick Setting #" + j + ": " + settings[i].substring(0, settings[i].indexOf('=')) + ", " + int(code));
                  wiimotes[curWiimote].chukStickBindings[j] = int(code);
                }
              }
              if (settings[i].substring(0, settings[i].indexOf('=')).equals(wiimotes[curWiimote].jsDefinitions[9])) {
                //println("Got joystick mode: " + settings[i].substring(0, settings[i].indexOf('=')) + ", " + code);
                wiimotes[curWiimote].chukStickMode = int(code);
              }
              if (settings[i].substring(0, settings[i].indexOf('=')).equals(wiimotes[curWiimote].jsDefinitions[10])) {
                //println("Got joystick threshold: " + settings[i].substring(0, settings[i].indexOf('=')) + ", " + code);
                wiimotes[curWiimote].chuckStickThreshhold = float(code);
              }
            }
            else {
              println("Invalid setting at line " + i + ": \"" + settings[i] + "\"");
            }
          }
          catch(Exception e) {
            println("An unknown error has occurred at line " + i);
          }
        }
      }
    }
    //Save parsed settings
    saveStrings(name, settings);
  }
}

